#version 300 es

layout (location = 0)in vec3 aPos;
layout (location = 1)in vec3 aNormal;

out vec3 FragPos;
out vec3 Normal;
out vec3 LightPos;
out vec4 diffuseLight;
out vec3 position;
out vec3 normal;

uniform vec3 vLight0;
uniform mat4 rotateMat;

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;
uniform mat4 center;

void main()
{
    FragPos = vec3(model*center * vec4(aPos, 1.0));
    Normal = mat3(transpose(inverse(model*center))) * aNormal;

    LightPos = vec3(view* vec4(0.0,0.0,1.0, 1.0));
//    vec3 worldNormal = vec3(vLight0* aNormal);
    vec3 worldNormal = normalize(vec3(projection* vec4(aNormal, 1.0)));
//    vec3 worldNormal =
//    vec3 worldNormal = vec3(mat3(projection[0].xyz, projection[1].xyz, projection[2].xyz) * aNormal);

//    diffuseLight = dot( worldNormal, normalize(-LightPos)) * vec4(1.0, 1.0, 1.0, 0.0);
    diffuseLight = dot( worldNormal, normalize(vec3(0.0,0.0,120.0))) * vec4(1.0, 1.0, 1.0, 0.0);

    gl_Position = projection * view  * vec4(FragPos, 1.0);

}
