#version 300 es

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;
uniform mat4 center;
uniform vec3 vLight0;
uniform mat4 rotateMat;

layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aTexCoords;

out vec3 FragPos;
out vec3 Normal;
out vec2 TexCoords;
out vec3 LightPos;
out vec4 diffuseLight;
out vec3 WorldPos;

void main()
{
    FragPos = vec3(model*center * vec4(aPos, 1.0));
    Normal = mat3(transpose(inverse(model))) * aNormal;
    TexCoords = aTexCoords;
    gl_Position = projection * view  * vec4(FragPos, 1.0);

    LightPos = vec3(view* vec4(vLight0, 1.0));


   // vec3 worldNormal = normalize(vec3(view* vec4(aNormal, 1.0)));
    // vec3 worldNormal = vec3(mat3(model[0].xyz, model[1].xyz, model[2].xyz) * aNormal);
    vec3 worldNormal = normalize(vec3(projection* vec4(aNormal, 1.0)));

    diffuseLight = dot( worldNormal, normalize(vec3(0.0,0.0,120.0))) * vec4(1.0, 1.0, 1.0, 0.0);
    //WorldPos = vec3(model * vec4(aPos, 1.0));
    WorldPos = aPos;
}
